***************************************
* author Brunello Pulix
*        Cagliari (Italy)
*        brunellopulix@gmail.com
*        placed in the public domain
***************************************
# include 'hbclass.ch'
# include 'common.ch'
*
FUNCTION MakeCell(cLabel,cSize,cAlignment,cBorder,cFormat,FieldNum,cPage_Day,cFont,cColor,cCargo)
  LOCAL oCell
  *
  hb_Default(@cLabel     ,'')
  hb_Default(@cAlignment ,'')
  hb_Default(@cCargo     ,'')
  hb_Default(@cBorder    ,'')
  hb_Default(@cFormat    ,'')
  hb_Default(@FieldNum   ,0)
  hb_Default(@cPage_Day  ,'')
  hb_Default(@cFont      ,'')
  hb_Default(@cColor     ,'0')
  hb_Default(@cCargo     ,'')
  *
  oCell           :=      QCell():New()
  oCell:Label     :=      cLabel
  oCell:Caption   :=      cLabel
  *
  oCell:Size   :=      cSize
  IF 'c' $ Lower(cAlignment)
     oCell:Alignment   :=      'c'
  ELSEIF 'r' $ Lower(cAlignment)
     oCell:Alignment   :=      'r'
  ELSEIF 'j' $ Lower(cAlignment)
     oCell:Alignment   :=      'j'
  ELSE
     oCell:Alignment   :=      'l'
  ENDIF
  IF 't' $ Lower(cAlignment)
     oCell:VertTop      := .T.
  ELSEIF "w" $ Lower(cAlignment)
     oCell:VertCenter   := .T.
  ELSE
     oCell:VertBot          := .T.
  ENDIF
  oCell:Border      :=      Upper(cBorder)
  IF "b" $ Lower(cFormat)
     oCell:bold              :=      .T.
  ENDIF
  IF "u" $ Lower(cFormat)
     oCell:Underline         :=      .T.
  ENDIF
  IF "i" $ Lower(cFormat)
     oCell:Italic            :=      .T.
  ENDIF
  oCell:FieldNum        :=      FieldNum
  IF "p" $ Lower(cPage_Day)
     oCell:Page       :=      .T.
  ENDIF
  IF "d" $ Lower(cPage_Day)
     oCell:day     :=      .T.
  ENDIF
  oCell:Font       :=    cFont
  If '/' $ cColor
     oCell:Color   := Left(cColor,at('/',cColor)-1)
     oCell:BackClr := Substr(cColor,at('/',cColor)+1)
  else
     oCell:color       :=    cColor
  endif
  oCell:Cargo    :=    Upper(cCargo)
  *
RETURN oCell
*
CLASS QCell
  DATA Label
  DATA Caption
  DATA Size
  DATA Font
  DATA Border
  DATA Bold
  DATA Underline
  DATA Italic
  DATA Alignment
  DATA FieldNum
  DATA Page
  DATA Day
  DATA Color
  DATA VertTop
  DATA VertCenter
  DATA VertBot
  DATA BackClr
  DATA Cargo
  METHOD New()
EndClass
*
METHOD New() CLASS QCell
  SELF:Label      :=  ""
  SELF:Caption    :=  ""
  SELF:Size       :=  "20"
  SELF:Font       :=  "0"
  SELF:Border     :=  ""
  SELF:Bold       :=  .F.
  SELF:Underline  :=  .F.
  SELF:Italic     :=  .F.
  SELF:Alignment  :=  "l"
  SELF:FieldNum   :=  0
  SELF:Page       :=  .F.
  SELF:Day        :=  .F.
  SELF:Color      :=  '0'
  SELF:BackClr    :=  ''
  SELF:VertBot    :=  .T.
  SELF:VertTop    :=  .F.
  SELF:VertCenter :=  .F.
  SELF:Cargo      :=  ""
RETURN SELF
